# neutron_lib.agent.extension module

class neutron_lib.agent.extension.AgentExtension

  Bases: `object`

  Define stable abstract interface for agent extensions.

  An agent extension extends the agent core functionality.

  consume_api(agent_api)

    Consume the AgentAPI instance from the AgentExtensionsManager.

    Allows an extension to gain access to resources internal to the neutron agent and otherwise unavailable to the extension. Examples of such resources include bridges, ports, and routers.

    Parameters:

      agent_api – An instance of an agent-specific API.

  abstractmethod initialize(connection, driver_type)

    Perform agent core resource extension initialization.

    Parameters:

      - connection – RPC connection that can be reused by the extension to define its RPC endpoints

      - driver_type – String that defines the agent type to the extension. Can be used to choose the right backend implementation.

    Called after all extensions have been loaded. No resource (port, policy, router, etc.) handling will be called before this method.

this page last updated: 2026-08-15 12:38:23

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug